package com.ca.SimpleTHreadSoundGeiger;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.RectF;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

import java.text.DecimalFormat;

import android.media.AudioFormat;
import android.media.AudioRecord;
import android.media.MediaRecorder;
//()V[G[ eF http://www.computerartisan.com
public class SimpleTHreadSoundGeiger extends Activity {
	private Context mContext ;
	private MySurfaceView mSurfaceView;

	// vON}CN̓͂̐ώZl
	public volatile int mRawGeigerCount;
	// Xbh~p̕ϐ
	boolean isEnd = false;
	// ߋ̈莞Ԃ̃JEg
	int mSumOfCountInHistry = 0;
	// N莞ԌoāALȃf[^oĂ邩ǂ
	boolean mIsEffectiveData = false;

	short mDebugSoundMax = 300;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		mSurfaceView = new MySurfaceView(this);
		setContentView(mSurfaceView);

	}

	@Override
	public void onStart() {
		super.onStart();
	}
	@Override
	public void onRestart() {
		super.onRestart();
	}
	@Override
	public void onResume() {
		super.onResume();
	}
	@Override
	public void onPause() {
		super.onPause();
	}

	@Override
	public void onStop() {
		super.onStop();
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
		isEnd = true;
	}
	@Override
	public boolean dispatchKeyEvent(KeyEvent event) {
		Log.d("SOUND","dispatchKey");
		if (event.getAction() == KeyEvent.ACTION_DOWN) {
			switch (event.getKeyCode()) {
			case KeyEvent.KEYCODE_BACK:
				new AlertDialog.Builder(this).setIcon(R.drawable.icon).setTitle("I܂?").setMessage("")
				.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int whichButton) {
						finish();
					}
				})
				.setNegativeButton("No", new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int whichButton) {
					}
				}).show();
				return true;
			case KeyEvent.KEYCODE_HOME ://androidł́AHOME ̃Cxg͎擾łȂƂɂȂĂ
				Log.d("SOUND","HOME down");
				return true ;
			default:
				break;
			}
		} else if (event.getAction() == KeyEvent.ACTION_UP) {
			switch (event.getKeyCode()) {
			case KeyEvent.KEYCODE_BACK:
				return true ;
			default:
				break;
			}
		}
		// ꂽ\bhEX^u
		return super.dispatchKeyEvent(event);
	}

	class MySurfaceView extends SurfaceView implements SurfaceHolder.Callback, Runnable {
		//Bitmap backGround ;
		Thread mThread ;
		static final int HISTORY_MAX = 120;
		int mStartupCountDown = HISTORY_MAX;

		int[] mHistry = new int[HISTORY_MAX];
		int mHistryPtr = 0;
		boolean isDestryOccur = false ;

		public MySurfaceView(Context context) {
			super(context);
			mContext = context ;
			getHolder().addCallback(this);

			// ThreadN
			mThread = new Thread(this);
			mThread.setDaemon(true);
			mThread.start();

		}

		@Override
		public void run() {
			//backGround = BitmapFactory.decodeResource(mContext.getResources(), R.drawable.background); 
			int rawLastGeigerCnt = mRawGeigerCount;
			int sumOfCount = 0;
			for (int i = 0; i < mHistry.length; i++) {
				mHistry[i] = 0;
			}
			SleepMs(300);
			Log.d("GAMEVIEW", "mGeigerDetect start");

			GeigerDetect mGeigerDetect = new GeigerDetect();
			mGeigerDetect.setDaemon(true);
			// mGeigerDetect.run();
			mGeigerDetect.start();

			while (!isEnd) {
				// OƂ̍߂
				int geiger = mRawGeigerCount;
				int deltaGeiger = geiger - rawLastGeigerCnt;
				rawLastGeigerCnt = geiger;
				Log.i("SOUND_GEIGER", "deltaGeiger=" + deltaGeiger);

				// ߋԕ̃JEgl߂
				sumOfCount -= mHistry[mHistryPtr];
				if (mHistry[mHistryPtr] > 0) {
					Log.i("SOUND_GEIGER", "minus " + mHistry[mHistryPtr]);
				}
				sumOfCount += deltaGeiger;
				mHistry[mHistryPtr] = deltaGeiger;
				mHistryPtr = incrimentHistryPtr(mHistryPtr);
				if (mHistryPtr == 0) {
					mIsEffectiveData = true;
				}

				// mSumOfCountInHistry ɓo^
				mSumOfCountInHistry = sumOfCount;
				if (mStartupCountDown > 0) {
					mStartupCountDown--;
				}
				Canvas canvas = getHolder().lockCanvas();
				if (canvas != null) {
					mSurfaceView.doDraw(canvas, mSumOfCountInHistry);
					getHolder().unlockCanvasAndPost(canvas);
				}
				SleepMs(500);
			}
		}

		void doDraw(Canvas canvas, int count) {
			Paint paint = new Paint();
			Log.d("TEST", "doDraw");

			canvas.drawColor(Color.WHITE);

			//c̗v]ŁA
			//canvas.drawBitmap(backGround, 0, 0, paint);
			
			paint.setColor(Color.BLACK);
			paint.setAntiAlias(true);
			paint.setTextSize(40);
			int offsetX = 40 ;
			int offsetY = 40 ;

			if (mIsEffectiveData) {
				double dblValue = count;
				dblValue /= 300.0;
				dblValue *= 1.8;
				//DecimalFormat df = new DecimalFormat("##.##");
				//df.setMaximumFractionDigits(2);
				//String sv = df.format(dblValue) + "uSv/h";
				//canvas.drawText(sv, 0, paint.getTextSize(), paint);
				String str = String.format("%2.2f", dblValue);
				str += "uSv/h";
				canvas.drawText(str, 0+offsetX, paint.getTextSize()+offsetY, paint);
			} else {
				paint.setTextSize(20);
				canvas.drawText("" + (mStartupCountDown / 2) + "b҂ ", 0+offsetX, paint.getTextSize()+offsetY, paint);
				paint.setTextSize(40);
			}

			canvas.drawText("Count: " + count, 0+offsetX, paint.getTextSize() * 2+offsetY, paint);

			paint.setTextSize(10);
			canvas.drawText("TotalCount: " + mRawGeigerCount, 0+offsetX, 120+offsetY, paint);
			paint.setTextSize(10);
			canvas.drawText("MaxSound: " + mDebugSoundMax , 0+offsetX, 140+offsetY, paint);
			mDebugSoundMax = 300;
			
			paint.setTextSize(30);
			canvas.drawText("ЃV[G[", 0 + offsetX, 300 + offsetY, paint);
		}
		@Override
		public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
			Log.d("TEST", "surfaceChanged");
		}

		@Override
		public void surfaceCreated(SurfaceHolder holder) {
		}

		@Override
		public void surfaceDestroyed(SurfaceHolder holder) {
			Log.d("TEST", "surfaceDestroyed");
		}

		int incrimentHistryPtr(int ptr) {
			ptr++;
			if (ptr >= mHistry.length) {
				ptr = 0;
			}
			return ptr;
		}
	}

	class GeigerDetect extends Thread {
		private static final int SAMPLE_RATE = 44100; // 8000, 11025, 22050
		//private static final int SAMPLE_RATE = 22050; // 8000, 11025, 22050

		int bufferSize = AudioRecord.getMinBufferSize(SAMPLE_RATE, AudioFormat.CHANNEL_CONFIGURATION_MONO, AudioFormat.ENCODING_PCM_16BIT);
		AudioRecord audioRecord = new AudioRecord(MediaRecorder.AudioSource.MIC, SAMPLE_RATE, AudioFormat.CHANNEL_CONFIGURATION_MONO,
				AudioFormat.ENCODING_PCM_16BIT, bufferSize * 4);
		short[] buffer = new short[bufferSize];

		@Override
		public void run() {
			android.os.Process.setThreadPriority(android.os.Process.THREAD_PRIORITY_URGENT_AUDIO);
			int remain = -1;
			// 8KhzTvOAignoreCount = 50,detectThreshold = 5000 Ŗ񔼕̒l
			// 44.1KhzTvOAignoreCount = 80,detectThreshold = 5000 ŏ
			final int ignoreCount = 160;// 1pulseẮǍ̔g`𖳎(SMB-20 ƁA80ʁASTS-5160)
			final int detectThreshold = 16000;
			short value;// Iɍ肽Ȃ̂łɒu(ӖȂ)
			int readCount, i;
			audioRecord.startRecording();
			while (!isEnd) {
				//Log.d("SOUND",".");
				readCount = audioRecord.read(buffer, 0, bufferSize);
				//mDebugSoundMax = Short.MIN_VALUE;
				for (i = 0; i < readCount; i++) {
					value = buffer[i];
					//if (value < 0) {
					//	value = (short) (-value);// Integer.abs ǂ
					//}
					if (value > mDebugSoundMax) {
						mDebugSoundMax = value;
					}
					if (remain > 0) {
						remain--;
						continue;
					}
					if (value > detectThreshold) {
						mRawGeigerCount++;
						remain = ignoreCount;
					}
				}
				SleepMs(1);
			}
			audioRecord.stop();
			audioRecord.release();
		}

	}

	void SleepMs(int ms) {
		try {
			Thread.sleep(ms);
		} catch (InterruptedException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		}
	}

}
